.TH mipdiag 8 "07 December 2001" "@VERSION@"
.SH NAME
mipdiag \- MIPL Mobile IPv6 diagnostics and configuration tool
.SH SYNOPSIS
.B mipdiag [-acdlmstIV?] [-S 
.I address 
.B -p 
.I integer 
.B [-A 
.I authentication algorithm
.B ] [-x] -D
.I direction
.B -k
.I authentication key
.B ] [-h 
.I ipv6-address/prefix-length 
.B -H 
.I [ipv6-address/prefix-length]
.B ] [-d
.I integer
.B ] [-r
.I access-control-rule
.B ] [-R
.I filename
.B ] [-t
.I boolean
.B ]
.SH DESCRIPTION
.B mipdiag
is diagnostics and configuration tool for MIPL Mobile IPv6 kernel
module. You can get statistics and state information with it and set
runtime parameters.

.SH COMMON OPTIONS

.IP "-?, --help"
Show usage information
.IP "-V, --version"
Display mipdiag and MIPL version information.
.IP "-c, --bcache"
Print binding cache entries
.IP "-d, --debuglevel [integer]"
Set or get debug level. Levels from 0 to 7 exist. Default: 0. If used
without argument, returns current value.
.IP "-s, --statistics"
Show general statistics

.SH HOME AGENT OPTIONS
.IP "-a, --access"
Print current access control list
.IP "-r, --rule acl-rule"
Set access control rule.
.IP "-R, --rulelist filename"
Read access control rules from filename.
.IP "-t, --tunnel_sitelocal [yes|no]"
Set or get option whether site-local packets to mobile node should be
tunneled. Default: yes. If called without argument, returns current
value.

.SH MOBILE NODE OPTIONS

.IP "-h, --homeaddress ipv6-address/prefix-length"
Set mobile node's home address to ipv6-address. Must be used with -H
option. New home addresses can be added to MN after startup with the
limitation that two different home addresses cannot share the same
home agent.
.IP "-H, --homeagent [ipv6-address/prefix-length]"
Set home agent address for mobile node. Must be used with -h
option. If address and prefix are omitted, Dynamic Home Agent Address
Discovery is initiated.
.IP "-m, --mninfo"
Print Mobile Node information
.IP "-l, --bulist"
Print binding update list entries
.IP "-I, --ifaces"
Show the currently available interfaces and their preferences.
.IP "-i, --if_name ifname"
Set name of interface for which -P sets the preference (e.g. eth0). 
.IP "-P, --set_if_pref preference"
Set preference for an interface (e.g. set preference 3 to eth0 :
"mipdiag -i eth0 -P 3" ). MN uses by default the interface with the
highest preference.  If a currently used interface is lost, MN
switches to the interface with the next highest preference and
performs a vertical handoff. The default preference is the interface
identifier of an interface.


.SH SECURITY OPTIONS

.IP "-S, --addsa address"
Add Security Association for peer with address.  Requires also spi,
algorithm, key and direction. The SA can be used either with IPSec AH,
which needs to be compiled into MIPL or the new authentication data
suboption which can be turened on by setting
/proc/sys/net/ipv6/mobility/use_auth to 1.
.IP "-p, --spi integer"
Defines security parameter index for a security association. Values
0-255 are reserved and should not be used. Must be unsigned integer.
.IP "-A, --algorithm"
Authentication algorithm used with this security association. Possible
values: "ALG_AUTH_HMAC_MD5" and "ALG_AUTH_HMAC_SHA1".
.IP "-D, --direction"
Direction for security association, either inbound or outbound.
.IP "-x, --hex"
Key is in hexadecimal format.
.IP "-k, --key"
Key for security association in base64 or hexadecimal format. If -x is
not used key is assumed to be in base64 format. Base64 key length with
HMAC Md5 is 22 characters and with HMAC SHA-1 27 characters. Valid
base64 characters:
"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz- .". 
In hexadecimal the maximum key lengths are 32 (128 bits) for HMAC
MD5 and 40 (160 bits)for HMAC SHA-1.
.IP "--showsa address"
Prints the security association(s) for the address to the console (or
kernel log). If no address is specified prints all security
associations.
.IP "--delsa address"
Deletes the security association(s) for the address.
.IP "--safile filename"
Adds security associations from a file.
.SH NOTES
For some reason, with short options optional arguments must be typed
without a space between the option and argument.

.SH EXAMPLES

.IP "mipdiag -h 3ffe:9999:1::1/64 -H"
Assign home address 3ffe:9999:1::1 with prefix length of 64 to mobile
node and start Dynamic Home Agent Address Discovery.

.SH BUGS
No known bugs.

.SH FILES
.I @sysconfdir@/network-mip6.conf
.RS
Mobile IPv6 main configuration file
.RE
.I @sysconfdir@/mipv6_acl.conf
.RS
Mobile IPv6 Access control file for home agent
.RE
.I /etc/mipv6_sas.conf
.RS
Mobile IPv6 security association configuration file.

.SH AUTHOR
Antti J Tuominen <ajtuomin@tml.hut.fi>
.SH "SEE ALSO"
.BR network-mip6.conf(5),
.BR mipv6_acl.conf(5),
.BR mipv6_sas.conf(5)






