.TH mipv6_sas.conf 5 "06 July 2001" "@VERSION@"
.SH NAME
mipv6_sas.conf \- MIPL Mobile IPv6 security associations 
.SH DESCRIPTION
.B mipv6_sas.conf
is the security associations configuration file for MIPL. This file is
normally used by mipdiag(8). It contains the security associations
with which a node can authenticate Mobile IPv6 signaling.

Security associations, or SAs, are unidirectional structures
consisting of the information used for building and verifying the
authentication header used in Mobile IPv6 signaling messages. To
enable authentication of home registration you need to set up a outbound
SA in the mobile node and an inbound SA in its home agent. You also
need to set up an inbound SA in the mobile node and an outbound SA in the
home agent for authentication of binding acknowledgements. You need to
set up a separate pair of SAs for each mobile node using the home
agent.

To enable direct communication between a mobile node and a correspondent
node you need to set up an outbound SA in the mobile node and an
inbound SA in the correspondent node. 

Each SA should be on its own line and fields separated with the charcter ";".

.SH FIELDS
.IP "address of the peer"
This field defines the peer used and needs to be defined. 
.IP "spi: spi"
SPI or security parameter index is used to demultiplex incoming
connections. Values below 256 are reserved. This field should be the
same in the inbound SA of one end and  outbound SA of the other end.
.IP "auth_alg: "
Defines the algorithm used for message authentication and also the key length.
Possible values:
.B ALG_AUTH_HMAC_MD5
:MD5 HMAC uses a key length of 128 bits. 
.B ALG_AUTH_HMAC_SHA1
SHA1 HMAC uses a key length of 160 bits.
.IP "direction: direction"
Direction of the SA. Either inbound or outbound.
.IP "key in hexadecimal" 
Whether key is in hexdecimal or base64 format. Set this to 1 for hexadecimal keys and 0 for base64 formatted keys.
.IP "key: authentication key" 
Key used for authentication with this SA.  The key is either in
hexadecimal or base64 format.  Hexadecimal keys should be 16 bytes for
HMAC-MD5 and 20 bytes for SHA-1.  The base64 keystring has 22
characters if MD5 HMAC is used and 28 if SHA1 HMAC is used. Valid
characters include :
'0'-'9', 'A'-'Z', 'a'-'z', '.', ' '  The same key should be used in inbound SA
 in one end and outbound in the other end.

 
.SH EXAMPLE
@sysconfdir@/mip6_sas.conf file in a home agent with SAs for a mobile node
with the home address 3ffe:2620:6:1234:abcd::1.

.PP
#address; spi; algorithm; direction; key in hex;  key
3ffe:2620:6:1234:abcd::1;1033;ALG_AUTH_HMAC_MD5;inbound;0;abcdefghijkl1234567890
3ffe:2620:6:1234:abcd::1;1034;ALG_AUTH_HMAC_MD5;outbound;0;1234567890abcdefghijkl

.SH AUTHOR
Henrik Petander <lpetande@tml.hut.fi>
.SH "SEE ALSO"
.BR mipdiag(8), 
.BR mipv6_sas.conf.example

